﻿Option Strict On
Imports System.Xml.Linq
Imports System.Net
Imports Microsoft.Phone.Shell

Public Class StationInfo
    Property name As String
    Property Latitude As String
    Property Longitude As String
End Class
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub
    Const AppID As String = "リクルートより取得したAPIキー"
    Shared no As Integer = 0
    Private Sub Button1_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Dim myUri As String = String.Format("http://api.doko.jp/v1/getStation.do?key={0}&name={1}", AppID, TextBox1.Text)
        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(New Uri(myUri, UriKind.Absolute))

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim xmldoc As XElement = XElement.Parse(resultArgs.Result)
                                                            Dim myStationInfo As New List(Of StationInfo)
                                                            For Each result In From c In xmldoc.Descendants("landmark") Select c
                                                                With myStationInfo
                                                                    .Add(New StationInfo With {.name = result.Element("name").Value,
                                                                                            .Latitude = result.Element("lat_jgd").Value,
                                                                                            .Longitude = result.Element("lon_jgd").Value})
                                                                End With
                                                            Next
                                                            resultListBox.ItemsSource = myStationInfo
                                                        End Sub
    End Sub

    Private Sub resultListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles resultListBox.SelectionChanged
        Try
            no = no + 1
            Dim myName As String = DirectCast(resultListBox.SelectedItem, StationInfo).name
            Dim myLatitude As String = DirectCast(resultListBox.SelectedItem, StationInfo).Latitude
            Dim myLongitude As String = DirectCast(resultListBox.SelectedItem, StationInfo).Longitude
            Dim myTileData As StandardTileData = New StandardTileData With {.Title = myName, .BackgroundImage = New Uri("Image/RedBorderBlack.png", UriKind.Relative), .Count = no}
            Dim myUri As Uri = New Uri(String.Format("/BingMapPage.xaml?name={0}&Latitude={1}&Longitude={2}", myName, myLatitude, myLongitude), UriKind.Relative)
            ShellTile.Create(myUri, myTileData)
        Catch
            Exit Sub
        End Try
    End Sub
End Class
